﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using System;
  using System.Text;

  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class Checksum : BenchmarkSuiteDataDescriptor {
    private const string name = "Checksum";
    private const string fileName = "Checksum.csv";
    private const string description = "";
    public Checksum() { }

    [StorableConstructor]
    public Checksum(bool deserializing) : base(deserializing) { }

    public override string Name { get { return name; } }
    protected override string FileName { get { return fileName; } }
    public override string Description { get { return description; } }
    public override int InputArgumentCount { get { return 1; } }
    public override int OutputArgumentCount { get { return 1; } }
    public override int OriginalTrainingCount { get { return 228; } }
    public override int OriginalTestCount { get { return 1254; } }
    public override int BestResult { get { return 0; } }
    public override int WorstResult { get { return byte.MaxValue; } }

    public override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputInt = Array.ConvertAll(Encoding.ASCII.GetBytes(input[0]), c => (long)c),
        OutputInt = Array.ConvertAll(Encoding.ASCII.GetBytes(output[0]), c => (long)c)
      };
    }
  }
}
