﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class CountOdds : BenchmarkSuiteDataDescriptor {
    private const string name = "Count Odds";
    private const string fileName = "CountOdds.csv";
    private const string description = "";

    public CountOdds() { }

    [StorableConstructor]
    public CountOdds(bool deserializing) : base(deserializing) { }

    public override string Name { get { return name; } }
    public override string Description { get { return description; } }
    protected override string FileName { get { return fileName; } }
    public override int InputArgumentCount { get { return 1; } }
    public override int OutputArgumentCount { get { return 1; } }
    public override int OriginalTrainingCount { get { return 200; } }
    public override int OriginalTestCount { get { return 2000; } }
    public override int BestResult { get { return 0; } }
    public override int WorstResult { get { return 50; } }

    public override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputInt = ConvertIntegers(input[0]),
        OutputInt = ConvertIntegers(output[0])
      };
    }
  }
}
